class Zeichen {

  void drawPermuationObj(PVector dir, PVector p1, PVector p2, float distValue, float tile, char permutation) {

    float dist;
    float scaler;

    switch(permutation)
    {
    case '1':
      //ellipse hat center default links oben, deshalb um hälfte des Tile translaten > ellipseMode(CENTER)
      translate(tile / 2, tile / 2);
      scaler = map(distValue, 0, width * 1.41, 0, 10);
      stroke(255);
      fill(255);
      ellipse(0, 0, 5 * scaler, 5 * scaler);
      break;

    case '2':
      translate(tile / 2, tile / 2);
      dist = map(distValue, 0, width, 0, 80);
      stroke(0);
      fill(255);
      ellipse(0, 0, tile, tile);
      fill(0);
      ellipse(0, 0, dist, dist);
      break;

    case '3':
      translate(tile / 2, tile / 2);
      stroke(255);
      float angle = atan2(p2.y - p1.y - tile / 2, p2.x - p1.x - tile / 2);
      distValue = sqrt(sq(p2.x - p1.x - tile / 2) + sq(p2.y - p1.y - tile / 2));
      float length = distValue * 0.4;
      line(0, 0, cos(angle) * length, sin(angle) * length);
      break;

    case '4':
      translate(tile / 2, tile / 2);
      float dirX = map(dir.x, 0, width, 0, 45);
      float dirY = map(dir.y, 0, height, 0, 45);
      stroke(255);
      fill(255);
      beginShape();
      vertex(-10, 0);
      vertex(10, 0);
      vertex(dirX, dirY);
      endShape(CLOSE);
      break;

    case '5':
      dist = map(distValue, 0, width * 1.41, 0, 100);
      stroke(0);
      fill(255);
      rect(0, 0, tile - 1, tile - 1);
      fill(0);
      rect(0, 0, dist, dist);
      rect(50, 50, dist, dist);
      break;

    case '6':
      float colorer = map(distValue, 0, width*1.41, 0, 255);
      fill(colorer);
      rect(0, 0, tile - 1, tile - 1);
      break;

    case '7':
      translate(tile / 2, tile / 2);
      dist = map(distValue, 0, width, -2, -50);
      fill(255);
      rotate(radians(180));
      for (int j=0; j<3; j++) {
        rotate(distValue/180);
        positionSmallTriangle(p1, tile / 2, dist);
      }
      break;

    case '8':
      stroke(255);
       line(p1.x-p2.x, p1.y-p2.y, p2.x/(p1.x/2), p2.y/(p1.y/2));
      break;

    case '9':
      stroke(255);
      rotate(radians(distValue*(map(p2.x, 0, width, -1, 1))));
      line(0, 0, 30, 30);
      break;
      
    case 'q':  
      stroke(255);
      noFill();
      rotate(radians(distValue/5));
      bezier(85,20, 10, 90, 90, 130, distValue/3, distValue/3);
      break;
      
     case 'w':
      translate(tile / 2, tile / 2);
      dist = map(distValue, 0, width * 1.41, 0, 40);
      stroke(0);
      fill(255);
      ellipse(0, 0, tile, tile);
      fill(0);
      ellipse(0, 0, dist, dist);
      break;

    case 'e':
      dist = map(distValue, 0, width, 0, 80);
      stroke(0);
      fill(255);
      ellipseMode(CORNER);
      ellipse(0, 0, tile, tile);
      fill(0);
      ellipseMode(CENTER);
      ellipse(0, 0, dist, dist);
      break;
    }
  }
}

void positionSmallTriangle(PVector p1, float width, float radius) {
  triangle(
    cos(radians(270)) * radius, sin(radians(270)) * radius, 
    cos(radians(150)) * width, sin(radians(150)) * width, 
    cos(radians(30)) * width, sin(radians(30)) * width
  );
}

