import fullscreen.*;

float     anzahlX;
float     anzahlY;
float     randX = 0;
float     randY;
float     tile;
float     trackerX;
float     trackerY;

HandCapture   handCapture;
FullScreen    fullScreen;

Zeichen zeichen = null;

PVector p1 = new PVector();
PVector p2 = new PVector();

float  xStep;
float  yStep;

char permutation = '3';

void setup()
{
  zeichen = new Zeichen();
  fullScreen = new FullScreen(this);
  fullScreen.enter();
  handCapture = new HandCapture(this);

  size (1024, 768);
  smooth();
  noStroke();
  noFill();
}

void draw()
{
  handCapture.update();
  background(0);
  PVector handPos = handCapture.handPos();
  float globX = randX;
  float globY = randY;
  
  randY = 128;

  if (handPos.z != 0.0) {
    anzahlX = map(handPos.z, 0, 3000, 0, 50);
  } else {
    anzahlX = 10;
  }
  println(handPos.z);
  anzahlY = anzahlX / 2;
  xStep = (width - 2 * randX) / (float)(anzahlX);
  yStep = (height - 2 * randY) / (float)(anzahlY);
  // berechnet die Grösse des Zeichens abhängig von der Grösse der canvas und der Anzahl gewünschter Zeichen
  tile = (width - 2 * randX) / anzahlX;

  if (handCapture.isHandTracked())
  {
    noCursor();
   /* Tracking point of hand while using kinect
    stroke(255, 0, 0);
    strokeWeight(8);
    point(handPos.x, handPos.y);
    popStyle();
    */
    trackerX = map(handPos.x, 0, 640, 0, width); // switch mouse & kinect
    trackerY = map(handPos.y, 0, 480, 0, height); // switch mouse & kinect
   
  }else{
    cursor();
    trackerX = mouseX;
    trackerY = mouseY;
  }
    
    for (int y=0; y < anzahlY; y++)
    {
      for (int x=0; x < anzahlX; x++)
      {
        float distValue = sqrt(sq(trackerX - globX) + sq(trackerY - globY));

        p1.set(globX, globY, 0);
        p2.set(trackerX, trackerY, 0);
        PVector dir = PVector.sub(p2, p1);

        //push und pop, damit man in der Zeichenklasse nicht dauernd bei jedem Translate pushen muss
        pushMatrix();
        pushStyle();
        translate(p1.x, p1.y);
        zeichen.drawPermuationObj(dir, p1, p2, distValue, tile, permutation);
        popStyle();
        popMatrix();

        globX += xStep;
      }
      globY += yStep;
      globX = randX;
    }
}

void keyPressed()
{
  permutation = key; 
}

/***********************************************/

void onCreateHands(int handId, PVector pos, float time)
{
  handCapture.onCreateHands(handId, pos, time);
}

void onUpdateHands(int handId, PVector pos, float time)
{
  handCapture.onUpdateHands(handId, pos, time);
}

void onDestroyHands(int handId, float time)
{
  handCapture.onDestroyHands(handId, time);
}

void onRecognizeGesture(String strGesture, PVector idPosition, PVector endPosition)
{
  handCapture.onRecognizeGesture(strGesture, idPosition, endPosition);
}

void onProgressGesture(String strGesture, PVector position, float progress)
{
  handCapture.onProgressGesture(strGesture, position, progress);
}

